#!/bin/sh
#
# bluetooth
#
# PCMCIA Bluetooth device initialization
# Original script by Maxim Krasnyanskiy <maxk@qualcomm.com>
#
# The original script has been adapted for the use of udev and the new
# kernel-based PCMCIA-system.
#

start_serial() {
	if [ -x /etc/rc.d/rc.bluez ]; then
	    /etc/rc.d/rc.bluez start
	fi
	
	IRQ=`setserial $DEVNAME | sed -e 's/.*IRQ: //'`
	setserial $DEVNAME irq 0 ; setserial $DEVNAME irq $IRQ

	DEVICE=`echo $DEVNAME|sed -e 's_/dev/__'`
	MANFID=`cat /$SYSFS/$PHYSDEVPATH/manf_id`","`cat /$SYSFS/$PHYSDEVPATH/card_id`
	# I don't have a generic solution, sorry
	if [ $MANFID = "0x0160,0x0002" ]; then
		/usr/sbin/hciattach $DEVICE $MANFID 115200
	else
		/usr/sbin/hciattach $DEVICE $MANFID
	fi
}

stop_serial() {
	fuser -k -HUP $DEVNAME > /dev/null
}

case "$ACTION" in
  add)
	start_serial
	;;
  remove)
	stop_serial
	;;
  *)
	echo "Unknown action received $0: $ACTION"
	;;
esac
